#include <hxcpp.h>

#ifndef INCLUDED_snow_platform_native_input_sdl_ModValue
#include <snow/platform/native/input/sdl/ModValue.h>
#endif
namespace snow{
namespace platform{
namespace native{
namespace input{
namespace sdl{

Void ModValue_obj::__construct()
{
	return null();
}

//ModValue_obj::~ModValue_obj() { }

Dynamic ModValue_obj::__CreateEmpty() { return  new ModValue_obj; }
hx::ObjectPtr< ModValue_obj > ModValue_obj::__new()
{  hx::ObjectPtr< ModValue_obj > result = new ModValue_obj();
	result->__construct();
	return result;}

Dynamic ModValue_obj::__Create(hx::DynamicArray inArgs)
{  hx::ObjectPtr< ModValue_obj > result = new ModValue_obj();
	result->__construct();
	return result;}

int ModValue_obj::NONE;

int ModValue_obj::LSHIFT;

int ModValue_obj::RSHIFT;

int ModValue_obj::LCTRL;

int ModValue_obj::RCTRL;

int ModValue_obj::LALT;

int ModValue_obj::RALT;

int ModValue_obj::LMETA;

int ModValue_obj::RMETA;

int ModValue_obj::NUM;

int ModValue_obj::CAPS;

int ModValue_obj::MODE;


ModValue_obj::ModValue_obj()
{
}

Dynamic ModValue_obj::__Field(const ::String &inName,bool inCallProp)
{
	switch(inName.length) {
	case 3:
		if (HX_FIELD_EQ(inName,"NUM") ) { return NUM; }
		break;
	case 4:
		if (HX_FIELD_EQ(inName,"NONE") ) { return NONE; }
		if (HX_FIELD_EQ(inName,"LALT") ) { return LALT; }
		if (HX_FIELD_EQ(inName,"RALT") ) { return RALT; }
		if (HX_FIELD_EQ(inName,"CAPS") ) { return CAPS; }
		if (HX_FIELD_EQ(inName,"MODE") ) { return MODE; }
		break;
	case 5:
		if (HX_FIELD_EQ(inName,"LCTRL") ) { return LCTRL; }
		if (HX_FIELD_EQ(inName,"RCTRL") ) { return RCTRL; }
		if (HX_FIELD_EQ(inName,"LMETA") ) { return LMETA; }
		if (HX_FIELD_EQ(inName,"RMETA") ) { return RMETA; }
		break;
	case 6:
		if (HX_FIELD_EQ(inName,"LSHIFT") ) { return LSHIFT; }
		if (HX_FIELD_EQ(inName,"RSHIFT") ) { return RSHIFT; }
	}
	return super::__Field(inName,inCallProp);
}

Dynamic ModValue_obj::__SetField(const ::String &inName,const Dynamic &inValue,bool inCallProp)
{
	switch(inName.length) {
	case 3:
		if (HX_FIELD_EQ(inName,"NUM") ) { NUM=inValue.Cast< int >(); return inValue; }
		break;
	case 4:
		if (HX_FIELD_EQ(inName,"NONE") ) { NONE=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"LALT") ) { LALT=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"RALT") ) { RALT=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"CAPS") ) { CAPS=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"MODE") ) { MODE=inValue.Cast< int >(); return inValue; }
		break;
	case 5:
		if (HX_FIELD_EQ(inName,"LCTRL") ) { LCTRL=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"RCTRL") ) { RCTRL=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"LMETA") ) { LMETA=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"RMETA") ) { RMETA=inValue.Cast< int >(); return inValue; }
		break;
	case 6:
		if (HX_FIELD_EQ(inName,"LSHIFT") ) { LSHIFT=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"RSHIFT") ) { RSHIFT=inValue.Cast< int >(); return inValue; }
	}
	return super::__SetField(inName,inValue,inCallProp);
}

void ModValue_obj::__GetFields(Array< ::String> &outFields)
{
	super::__GetFields(outFields);
};

static ::String sStaticFields[] = {
	HX_CSTRING("NONE"),
	HX_CSTRING("LSHIFT"),
	HX_CSTRING("RSHIFT"),
	HX_CSTRING("LCTRL"),
	HX_CSTRING("RCTRL"),
	HX_CSTRING("LALT"),
	HX_CSTRING("RALT"),
	HX_CSTRING("LMETA"),
	HX_CSTRING("RMETA"),
	HX_CSTRING("NUM"),
	HX_CSTRING("CAPS"),
	HX_CSTRING("MODE"),
	String(null()) };

#if HXCPP_SCRIPTABLE
static hx::StorageInfo *sMemberStorageInfo = 0;
#endif

static ::String sMemberFields[] = {
	String(null()) };

static void sMarkStatics(HX_MARK_PARAMS) {
	HX_MARK_MEMBER_NAME(ModValue_obj::__mClass,"__mClass");
	HX_MARK_MEMBER_NAME(ModValue_obj::NONE,"NONE");
	HX_MARK_MEMBER_NAME(ModValue_obj::LSHIFT,"LSHIFT");
	HX_MARK_MEMBER_NAME(ModValue_obj::RSHIFT,"RSHIFT");
	HX_MARK_MEMBER_NAME(ModValue_obj::LCTRL,"LCTRL");
	HX_MARK_MEMBER_NAME(ModValue_obj::RCTRL,"RCTRL");
	HX_MARK_MEMBER_NAME(ModValue_obj::LALT,"LALT");
	HX_MARK_MEMBER_NAME(ModValue_obj::RALT,"RALT");
	HX_MARK_MEMBER_NAME(ModValue_obj::LMETA,"LMETA");
	HX_MARK_MEMBER_NAME(ModValue_obj::RMETA,"RMETA");
	HX_MARK_MEMBER_NAME(ModValue_obj::NUM,"NUM");
	HX_MARK_MEMBER_NAME(ModValue_obj::CAPS,"CAPS");
	HX_MARK_MEMBER_NAME(ModValue_obj::MODE,"MODE");
};

#ifdef HXCPP_VISIT_ALLOCS
static void sVisitStatics(HX_VISIT_PARAMS) {
	HX_VISIT_MEMBER_NAME(ModValue_obj::__mClass,"__mClass");
	HX_VISIT_MEMBER_NAME(ModValue_obj::NONE,"NONE");
	HX_VISIT_MEMBER_NAME(ModValue_obj::LSHIFT,"LSHIFT");
	HX_VISIT_MEMBER_NAME(ModValue_obj::RSHIFT,"RSHIFT");
	HX_VISIT_MEMBER_NAME(ModValue_obj::LCTRL,"LCTRL");
	HX_VISIT_MEMBER_NAME(ModValue_obj::RCTRL,"RCTRL");
	HX_VISIT_MEMBER_NAME(ModValue_obj::LALT,"LALT");
	HX_VISIT_MEMBER_NAME(ModValue_obj::RALT,"RALT");
	HX_VISIT_MEMBER_NAME(ModValue_obj::LMETA,"LMETA");
	HX_VISIT_MEMBER_NAME(ModValue_obj::RMETA,"RMETA");
	HX_VISIT_MEMBER_NAME(ModValue_obj::NUM,"NUM");
	HX_VISIT_MEMBER_NAME(ModValue_obj::CAPS,"CAPS");
	HX_VISIT_MEMBER_NAME(ModValue_obj::MODE,"MODE");
};

#endif

Class ModValue_obj::__mClass;

void ModValue_obj::__register()
{
	hx::Static(__mClass) = hx::RegisterClass(HX_CSTRING("snow.platform.native.input.sdl.ModValue"), hx::TCanCast< ModValue_obj> ,sStaticFields,sMemberFields,
	&__CreateEmpty, &__Create,
	&super::__SGetClass(), 0, sMarkStatics
#ifdef HXCPP_VISIT_ALLOCS
    , sVisitStatics
#endif
#ifdef HXCPP_SCRIPTABLE
    , sMemberStorageInfo
#endif
);
}

void ModValue_obj::__boot()
{
	NONE= (int)0;
	LSHIFT= (int)1;
	RSHIFT= (int)2;
	LCTRL= (int)64;
	RCTRL= (int)128;
	LALT= (int)256;
	RALT= (int)512;
	LMETA= (int)1024;
	RMETA= (int)2048;
	NUM= (int)4096;
	CAPS= (int)8192;
	MODE= (int)16384;
}

} // end namespace snow
} // end namespace platform
} // end namespace native
} // end namespace input
} // end namespace sdl
